/*
 * vbmp3_m.cpp
 *  VBMP3 O[of[^
 *
 *  This file is part of the VBMP3 package.
 *
 *  VBMP3, MP3 Operating Library
 *  originally Copyright (C) 1999-2000 Daisuke Karikomi
 *
 *  Portions Copyright (C) 2002 Kobarin
 *  Portions Copyright (C) 2002 Lenn
 */

#include "MP3Enc.h"
#include "MP3Input.h"
#include "MP3Output.h"

/* MP3Enc *********************************************************************/
HANDLE			m_hEncThread;			//GR[hpXbh
int				m_encThreadID;			//GR[hpXbhID

BYTE*			m_pFormat;
DWORD			m_dataSize;
HANDLE			m_hSrcFile;
HANDLE			m_hDstFile;
BYTE			m_srcBlock[8192];
BYTE			m_dstBlock[2048];
ACMSTREAMHEADER	m_ash;
MMRESULT		m_mmr;
HACMDRIVER		m_had;
HACMSTREAM		m_has;
int				m_encoded = 0;
int				m_readed = 0;
int				m_encState;

int				m_enc_channels;
int				m_enc_samplingRate;

/* MP3Input *******************************************************************/
/* Đt@C֘A */
HANDLE		m_hWaveFile;				//WAVEt@C
HANDLE		m_hFile;					//Ώۂ̃t@C
char		m_openFileName[260];		//Ώۃt@C
wchar_t		m_openFileNameW[32769];			//Ώۃt@C
DWORD		dataSize;					//MPEG Audiof[^TCY
int			fileSize;					//MPEG t@CTCY
MPEG_DECODE_INFO m_decInfo;				//MPEGwb_
int			m_playSec;					//toߎ
int			m_playSecCur;				//toߎ(o͗p)
int			m_totalSec;					//t
long		m_totalMs;					//t(ms)
int			m_winampTotalSec;			//winampt
long		m_winampTotalMs;			//winampt(ms)
double		m_playMs;					//t̎ԁi~bj
int			m_playFrames;				//tt[
int			m_playSamples;				//tTv
TAG_INFO	tagInfo;					//^O
LIST_INFO	listInfo;					//Xg
int			m_FileType;					//َ̧
BOOL		m_openFileVBR;				//True = VBR` False = ̑

/* VBMP3 ֘A */
MPEG_DECODE_OPTION   decodeOption;		//fR[hGWIvV
int			m_lvol;						//{|
int			m_rvol;						//E{|
int			m_olvol;					//o̓{|
int			m_orvol;					//Eo̓{[
BOOL		m_fadeOutFlag = false;		//tF[hAEgݒ
int			m_inputBlock = 30;			//̓t[
int			m_outputBlock_in = 20;		//o̓t[
int			m_outputBlock_in_tmp = 20;	//o̓t[(ꎞۑ)
int			m_outputBlock_in_wav = 5;	//o̓t[(sb`ύX)
int			m_inputSleep = 5;			//͒̃X[v(~b)
int			decFlag;					//fR[htO 0:Đ 1:Waveo 2:ĐȂWAVEo
int			m_platForm;					//1:WinNT 0:̑
BOOL		m_timeFlag = TRUE;			//TRUE:tԂԉz؂̂

//Đxp
double		m_playSpeed;				//Đx
int			m_reduction;				//_ETvO
int			m_bitRate;					//Đ[g

/* t֘A */
HANDLE		m_hThread;					//fR[hpXbh
int			m_threadID;					//fR[hpXbhID
int			m_firstSync;				//ŏ̓wb_ʒu
int			m_firstSample;				//Tv̈ʒu
double		m_msPerFrame;				//1t[̉tԁi~bj
int			m_state;					//݂̏
int			m_stateWork;				//V[NA[Ǝ̌̏
int			decodePos;					//ĐԌvZp

BYTE*		m_inputBuf;					//̓obt@iMPEG Audioj
BYTE*		m_inputPtr;					//̓|C^
int			m_inputSize;				//̓obt@TCY
int			m_inputBytes;				//fR[hĂȂobt@TCY
BYTE*		m_outputBuf_in;				//o̓obt@iPCMj
int			m_readWaveDataSize;			//WAVEǍTCY
int			m_frameReadFlag = 0;		//t[擾@ 0:ʏ 1:t@CS
BOOL		m_seekFlag = FALSE;			//V[NȂ TRUE
BOOL		m_reloadFlag = FALSE;		//[hȂ TRUE
BOOL		m_stepFlag = FALSE;			//TRUE:ςȂsb`ύX
BOOL		m_seekPlayFlag = FALSE;		//TRUE:~ɃV[NꂽƂĐJn
BOOL		m_playFlag = FALSE;			//PłĐꂽ TRUE
BOOL		m_quickSeek = TRUE;			//V[Nsꍇ TRUE

/* R[obN֘A */
INPUT_MSG_PROC	m_pProc;					//R[obN֐
int			m_userData;					//R[obN֐p[^
BOOL		callBackFlag = FALSE;		//R[obN֐gpL
TIMER_PROC	m_pTimerProc;				//R[obN^C}֐
BOOL		callBackTimerFlag = FALSE;	//R[obN^C}֐gpL
int			m_timerUserData;			//R[obN^C}֐p[^
UINT		m_timerId;					//^C}[ID
BOOL		m_timeCall = FALSE;			//^C}[R[tO
BOOL		m_OnCall = FALSE;			//R[obN

/* ̎֘A */
LYRICS_WORK	m_lyrics[1000];				//̎
int			m_liricsLinePointMax[1000];	//s̃^O
int			m_lyricsCount = 0;			//^O
int			m_lyricsLineNo = 0;			//̎s
int			m_lyricsCurrent;			//Jgʒu 0`1000
int			m_lyricsTotalFlag = 0;		//̎\Ɏgp鎞(0:Winamp݊ 1:W 2:ݒ背[g)
long		m_lyricsAdjustTime = 0;		//̎ؑ֒
long		m_lyricsNextAdjustTime = 0;	//̎sؑ֒
BOOL		m_Lyrics3UseFlag = FALSE;	//Lyrics3 ̎gpI
BOOL		m_KaraokeTagFlag = FALSE;	//JIP^OgpI
BOOL		m_ExistKaraokeTag = FALSE;	//JIP^O̗L
BOOL		m_ExistTimeTag = FALSE;		//^C^O̗L
int			m_Lyrics3InsertPoint = 0;	//LYRICS3^O}ʒu 0:ILYC 1:IID3 2:
int			m_NotTagLineRead = 1;		//̎̋sǍ 0: 1:L
AT_TAG		m_atTag;					//^Of[^
int			m_atTagUseFlag = 0;			//̈ 0: 1:^Ogp 2:Jns
double		m_timeRatio;				//ԗ

/* ^O֘A */
int			m_listChunkPoint;			//`Nʒuۑp
int			m_listChunkSize;			//`NTCYۑp
int			RiffStatus;					//MpegCheck
int			m_NotDataSiWrite = 1;		//f[^̃tB[h 0: 1:L

/* WAVEt@C֘A */
WAVEFORMATEX	m_waveFormat;				//WAVEtH[}bg
BOOL		m_waveFlag;					//I[vt@CPCMȂTRUE
int			m_outWaveBufSize;			//oWAVEobt@TCY
int			m_inWaveBufSize;			//WAVEobt@TCY

//We[u
const char *genre_tbl[256] = {
"Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk", "Grunge", "Hip-Hop",
"Jazz", "Metal", "New Age", "Oldies", "Other", "Pop", "R&B", "Rap",
"Reggae", "Rock", "Techno", "Industrial", "Alternative", "Ska", "Death Metal", "Pranks",
"Soundtrack", "Euro-tecno", "Ambient", "Trip-Hop", "Vocal", "Juzz+Funk", "Fusion", "Trance",
"Classical", "Instrumental", "Acid", "House", "Game", "Sound Clip", "Gospel", "Noise",
"AlternRock", "Bass", "Soul", "Punk", "Space", "Meditative", "Instrumental Pop", "Instrumental Rock",
"Ethnic", "Gothic", "Darkwave", "Techno-Industrial", "Electronic", "Pop-Folk", "Eurodance", "Dream",
"Southern Rock", "Comedy", "Cult", "Gangsta", "Top 40", "Christian Rap", "Pop/Funk", "Jungle",

"Native American", "Cabaret", "New Wave", "Psychadelic", "Rave", "Showtunes", "Trailer", "Lo-Fi",
"Tribal", "Acid Punk", "Acid Jazz", "Polka", "Retro", "Musical", "Rock & Roll", "Hard Rock",
"Folk", "Folk/Rock", "National Folk", "Swing", "Fast-Fusion", "Bedob", "Latin", "Revival",
"Celtic", "Bluegrass", "Avantagarde", "Gothic Rock", "Progressive Rock", "Psychadelic Rock", "Symphonic Rock", "Slow Rock",
"Big band", "Chorus", "Easy Listening", "Acoustic", "Humour", "SpeechChanson", "Chanson", "Opera",
"Chamber Music", "Sonata", "Symphony", "Booty Bass", "Primus", "Porn Groove", "Satire", "Slow Jam",
"Club", "Tango", "Samba", "Folklore", "Ballad", "Power Ballad", "Rhytmic Soul", "Freestyle",
"Duet", "Punk Rock", "Drum Solo", "Acapella", "Euro-House", "Dance Hall", "Goa", "Dram & Bass",

"Club-House", "Hardcore", "Terror", "Indie", "BritPop", "Negerpunk", "Polsk Punk", "Beat",
"Chiristian Gangsta Rap", "Heavy Metal", "Black Metal", "Crossover", "Contemporary Christian", "Christian Rock", "Merengue", "Salsa",
"Thrash Metal", "Anime", "JPop", "Synthpop", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",

"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "", "", "", "", "",
"", "", "", "Seiyu(J)", "Tecno Ambient(J)", "Moemoe(J)", "Tokusatsu(J)", "Anime(J)"

};

//VBR pt[ԃe[u
const double ms_table[3][3] =
{
// Layer1
{8.707483f, 8.0f, 12.0f},
// Layer2
{26.12245f, 24.0f, 36.0f},
// Layer3
{26.12245f, 24.0f, 36.0f},
};

/* MP3Output ******************************************************************/
HWAVEOUT		m_hWaveOut;					//I[fBIo̓foCX
//HANDLE			m_out_hThread;
//int				m_out_threadID;

//HANDLE			m_hSemaphore;				//f[^ubNpZ}tH
//폜 by Kobarin
CRITICAL_SECTION m_cs;						//eϐ p

int			m_channels;
int			m_bitsPerSample;
int			m_blockSize;

int			m_outputBlock;
int			m_outputIndex;
int			m_outputFinished;
BYTE**		m_outputTable;

//boolean			m_analyze = false;
//boolean			m_analyzeThread = false;
//int				m_specTableL[256];
//int				m_specTableR[256];

int			m_waveBlock;
int			m_waveIndex;				//WAVEHDR CfbNX
//int				m_waveStack;				//Đ WAVEHDR 
//int				m_waveCount = 16;				//WAVEHDR z
WAVEHDR*		m_waveTable;				//WAVEHDR i[e[u

BYTE*		m_outputPtr;
int			m_outputBytes;
int			m_outputSize;
int			m_pitch = 100;				//sb`(%)

/*
BYTE*		m_outputBuf;
BYTE*		m_outputPtr;
int			m_outputSize;
int			m_outputBytes;
*/
int			m_outputSleep = 0;

int			m_lSoftVol;				//\tgEFA{[()
int			m_rSoftVol;				//\tgEFA{[(E)
int			m_lMaxSoftVol = 100;	//ő\tgEFA{[()
int			m_rMaxSoftVol = 100;	//ő\tgEFA{[(E)
BOOL		m_fadeIn;
BOOL		m_fadeOut;

BOOL		m_stepPitch;

int			m_deviceId = WAVE_MAPPER;		//foCXID

int			m_fftWindow = hanning;

/* vbmp3_common ***************************************************************/
/** fobO **/
long		debugNo = 0;					//fobOp
long		errorNo = 0;					//G[ԍ
